nxt.ae

## Class AssetExchangeTransactionType<Att extends Attachment>

- java.lang.Object
- - nxt.blockchain.TransactionType
  - - nxt.blockchain.ChildTransactionType
    - - nxt.ae.AssetExchangeTransactionType<Att>

-     public abstract class AssetExchangeTransactionType<Att extends Attachment>
      extends ChildTransactionType

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static TransactionType` | `ASK_ORDER_CANCELLATION`
    `static TransactionType` | `ASK_ORDER_PLACEMENT`
    `static TransactionType` | `ASSET_DELETE`
    `static TransactionType` | `ASSET_INCREASE`
    `static TransactionType` | `ASSET_ISSUANCE`
    `static TransactionType` | `ASSET_PROPERTY_DELETE`
    `static TransactionType` | `ASSET_PROPERTY_SET`
    `static TransactionType` | `ASSET_TRANSFER`
    `static TransactionType` | `BID_ORDER_CANCELLATION`
    `static TransactionType` | `BID_ORDER_PLACEMENT`
    `static TransactionType` | `DIVIDEND_PAYMENT`
    `static TransactionType` | `SET_PHASING_CONTROL`

    - ### Fields inherited from class nxt.blockchain.ChildTransactionType

      `TYPE_ACCOUNT_CONTROL, TYPE_ACCOUNT_PROPERTY, TYPE_ALIASES, TYPE_ASSET_EXCHANGE, TYPE_COIN_EXCHANGE, TYPE_DATA, TYPE_DIGITAL_GOODS, TYPE_LIGHT_CONTRACT, TYPE_MESSAGING, TYPE_MONETARY_SYSTEM, TYPE_PAYMENT, TYPE_SHUFFLING, TYPE_VOTING`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `checkLiquid(ChildTransaction transaction)`
    `static TransactionType` | `findTransactionType(byte subtype)`
    `abstract long` | `getAssetId(ChildTransaction transaction)`
    `byte` | `getType()`
    `protected void` | `validateAttachment(ChildTransactionImpl transaction)`
    `protected abstract void` | `validateAttachment(ChildTransactionImpl transaction, Att attachment)`

    - ### Methods inherited from class nxt.blockchain.ChildTransactionType

      `apply, applyAttachment, applyAttachment, applyAttachmentUnconfirmed, applyAttachmentUnconfirmed, applyUnconfirmed, findTransactionType, getBaselineFee, undoAttachmentUnconfirmed, undoAttachmentUnconfirmed, undoUnconfirmed, validateAttachment, validateId, validateId`

    - ### Methods inherited from class nxt.blockchain.TransactionType

      `canHaveRecipient, getBaselineFeeHeight, getLedgerEvent, getName, getNextFee, getNextFeeHeight, getSubtype, isBlockDuplicate, isDuplicate, isDuplicate, isDuplicate, isGlobal, isPhasable, isPhasingSafe, isPruned, isUnconfirmedDuplicate, mustHaveRecipient, parseAttachment, parseAttachment, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### ASSET_ISSUANCE

          public static final TransactionType ASSET_ISSUANCE

    - #### ASSET_TRANSFER

          public static final TransactionType ASSET_TRANSFER

    - #### ASSET_DELETE

          public static final TransactionType ASSET_DELETE

    - #### ASSET_INCREASE

          public static final TransactionType ASSET_INCREASE

    - #### ASK_ORDER_PLACEMENT

          public static final TransactionType ASK_ORDER_PLACEMENT

    - #### BID_ORDER_PLACEMENT

          public static final TransactionType BID_ORDER_PLACEMENT

    - #### ASK_ORDER_CANCELLATION

          public static final TransactionType ASK_ORDER_CANCELLATION

    - #### BID_ORDER_CANCELLATION

          public static final TransactionType BID_ORDER_CANCELLATION

    - #### DIVIDEND_PAYMENT

          public static final TransactionType DIVIDEND_PAYMENT

    - #### SET_PHASING_CONTROL

          public static final TransactionType SET_PHASING_CONTROL

    - #### ASSET_PROPERTY_SET

          public static final TransactionType ASSET_PROPERTY_SET

    - #### ASSET_PROPERTY_DELETE

          public static final TransactionType ASSET_PROPERTY_DELETE

  - ### Method Detail

    - #### findTransactionType

          public static TransactionType findTransactionType(byte subtype)

    - #### getType

          public final byte getType()

      Specified by:
        `getType` in class `TransactionType`

    - #### getAssetId

          public abstract long getAssetId(ChildTransaction transaction)

    - #### validateAttachment

          protected final void validateAttachment(ChildTransactionImpl transaction)
                                           throws NxtException.ValidationException

      Specified by:
        `validateAttachment` in class `ChildTransactionType`
      Throws:
        `NxtException.ValidationException`

    - #### checkLiquid

          protected void checkLiquid(ChildTransaction transaction)
                              throws NxtException.NotCurrentlyValidException

      Throws:
        `NxtException.NotCurrentlyValidException`

    - #### validateAttachment

          protected abstract void validateAttachment(ChildTransactionImpl transaction,
                                                     Att attachment)
                                              throws NxtException.ValidationException

      Throws:
        `NxtException.ValidationException`